////////////////////////////////////////////////////////////////////////////////
//Copyright(c)2005-(c)2008 Internet Archive. Software license GPL version 2.



// encrapsulate all our functions and variables.  no globals!
var IAPlay = {

// constants
CLIK2PLAYWIDTH:320,
CLIK2PLAYHEIGHT:240,
CONTROLLER_HEIGHT:26,
AUDIO_HEIGHT:220,
FLASH_WIDTH:640,
VIDEO_HEIGHT:480,


// why do flash use commas, why?
// (NOTE: flowplayer detection ignores a middle ",0" substring)
MIN_FLASH_VERSION:[7,0],   // the bare minimum -- a C- student
MP4_FLASH_VERSION:[9,115], // this one can play h.264-encoded .mp4!


// id name of the div we will insert the player at ...
flowplayerdiv:'flowplayerdiv',  //can in theory (rarely? ever now?) be overridden

  
player:null, // flowplayer JS API object

playlists:null, // contains movies and audio playlist info and other stuff
flowplayerplaylist:null, // DOM obj of playlist div (if there is one)


ready:false,
movie:false,
hold:false,
captions:[],
captioned:false,
lastCaptionID:'',
start:0,  // location (in seconds) to seek player to (when relevant)
htm5:false,   // use the HTML5 <video> or <audio> tag (instead of flash)?
tryingHTM5:false, // single one-off trying <audio>/<video> tag now?
playingClipNum:0, // only for <video> tag now, but could be used more in future
embedTag:false,
playing264:false,
flashFailed:false,
audioSharingShowing:false,

flowdir:'http://'+location.host+'/flow/',
playerSwfUrl:'http://'+location.host+'/flow/flowplayer.commercial-3.2.1.swf',
emptySRT:'http://'+location.host+'/includes/empty.srt',

names:[],
urls:[],


insertPlayer:function(playlists) // convenience legacy function
{
  this.configPlayer(playlists);
  return this.showPlayer();
},



// input argument is an object with the following keys/names:
// (for audio)
//   mp3s
//   names
//   lengths
// (for movies)
//   identifier
//   mp4s
//   mp4names
//   flvnames (optional)
//   flvs     (optional)
//   srts     (optional)
configPlayer:function(playlists)
{
  // http://ejohn.org/blog/ecmascript-5-strict-mode-json-and-more/
  if (location.host=='www-tracey.archive.org') { "use strict"; }
     
        
  this.playlists = playlists;

  if (typeof(playlists.flowplayerdiv)!='undefined') // ...unless overridden by arg
    this.flowplayerdiv = playlists.flowplayerdiv;

  var autoPlay = true;
  if (typeof(playlists.autoPlay)!='undefined') // ...unless overridden by arg
    autoPlay = playlists.autoPlay;
  
  
  
  // see if we are a movie
  var movie = 0 <
    ((typeof(playlists.flvs)=='undefined' ? 0 : playlists.flvs.length)  +
     (typeof(playlists.mp4s)=='undefined' ? 0 : playlists.mp4s.length));
  this.movie = movie;


  if (navigator.userAgent.indexOf('iPhone') >= 0  ||
      navigator.userAgent.indexOf('iPad'  ) >= 0  ||
      navigator.userAgent.indexOf('iPod'  ) >= 0)
  {
    // the HTTP user agent appears to be an iphone/ipod/ipad -- don't bother w/
    // trying flash and use the <video>/<audio> tag directly
    this.htm5 = (this.movie ? 'video' : 'audio');
  }
  

  /************* SETUP THE PLAYLIST AND EMBED FLASH! ***************/ 

  if (!movie)
  {
    this.urls  = playlists.mp3s;
    this.names = playlists.names;
  }
  else
  {
    if (playlists.mp4s.length)
    {
      // keep only the mp4s
      this.urls  = playlists.mp4s;
      this.names = playlists.mp4names;
      this.playing264 = true;
    }
    else if (typeof(playlists.flvs)!='undefined'  &&  playlists.flvs.length)
    {
      // either only flash videos OR client's flash plugin can only handle flash
      // video (and shockwave) clips (and not h.264 clips)
      this.urls  = playlists.flvs;
      this.names = playlists.flvnames;
    }
  }

  

  if (!this.urls  ||  this.urls.length==0)
  {
    this.warn('Sorry!  no clips in this item could be played with your flash plugin.');
    return;
  }
  

  // newer browsers like FF 3.5+ and Safari 4+ can play new <video>/<audio> tag!
  // check for browsers that can handle the <video> tag natively...
  // (credit to J at v2v dot cc for this simpler JS detection technique!)
  var video = document.createElement('video');
  if (video.play)
  {
    var obj = document.getElementById('flowplayercontainer');
    if (obj)
    {
      var tryVideoTag = document.createElement('div');
      tryVideoTag.style.paddingTop = 2;
      tryVideoTag.style.backgroundColor = 'white';
      if (!this.getCookie('videoTag'))
      {
        tryVideoTag.innerHTML = '<div id="tryVideo" style="font-size:90%; border:1px dashed #ddd; background-color:#f0f0f0; padding:2px; width:300px; margin:auto;">Your browser supports the new &lt;'+(movie?'video':'audio')+'&gt; tag!<br>Would you like to <nobr><a onclick="return IAPlay.tryVideoTag()" href="#">try the new &lt;'+(movie?'video':'audio')+'&gt; tag</a></nobr>?</div>';
      }
      else
      {
        this.htm5 = (movie?'video':'audio');
        tryVideoTag.innerHTML = '<div id="tryVideo" style="font-size:90%; padding:2px;">(<a href="#" onclick="return IAPlay.uncookieVideoTag()">Click here</a> to stop using the &lt;'+this.htm5+'&gt; tag)</a>';
      }
      obj.appendChild(tryVideoTag);
    }
  }

  
  
  

  // tracey jan2009 -- next 2 notes were true for older flowplayer, not sure now--
  //   but we certainly want fully qualified IA playlist urls for offsite
  //   embedding of our flash player and movies on people's sites/blogs!
  // NOTE: for audio embedding, make it the fully qualified url
  // NOTE: have to make it the same as the host where this JS is loaded from
  // or else clicking on playlist rows fails, etc.
  var playListAry = [];
  for (var i=0, url; url = this.urls[i]; i++)
  {
    if (url.match(/\/\/localhost\//))
      playListAry[i] = url;
    else
      playListAry[i] = url;
    
    if (!movie  &&  i==0)
      playListAry[0] = { url:playListAry[0], autoPlay:false };
  }

  
  // save whether or not we are to jump into the movie...
  this.start = (this.urls == playlists.mp4s ? // for .mp4s
                (this.arg('start') ? parseFloat(this.arg('start')) : 0) : 0);
    
  //console.log(playListAry);
  //console.log(this.names);

  // have to swap out most non-simple chars (boo hoo!) for safe transporting to
  // the viral plugin(s)...
  var ttl = (typeof(playlists.title)=='undefined' ? playlists.identifier :
             playlists.title.replace(/[^-A-Za-z0-9_ ]/g, ' '));
  //console.log(ttl);
  
  var config = {
    key: '#$aa4baff94a9bdcafce8',
    playlist: playListAry,
    clip: {
      autoPlay:autoPlay,
      baseUrl:'http://'+location.host+'/download/'+playlists.identifier+'/'
    },
    canvas:
    {
      backgroundColor: '#000000',
      backgroundGradient: 'none'
    },
    plugins: 
    {
      audio:
      {
        url:this.flowdir+'flowplayer.audio-3.2.1-dev.swf'
      },
      controls:
      {
        playlist:    (playListAry.length > 1 ? true : false),
        fullscreen:  (movie?true:false),
        height: this.CONTROLLER_HEIGHT,
        backgroundColor: '#000000',
        autoHide: { fullscreenOnly:true }
      },
      viral:
      {
        url: this.flowdir+'flowplayer.viralvideos-3.2.1-dev.swf',
        embed:false,
        email:false,
        share:
        {
          title: ((this.movies ?
                   'Click on an icon to share this video' :
                   'Click an icon to share this recording') +
                  "\n(allow pop ups for this feature)"),
          description: ttl + ' at archive.org',
          livespaces: false // disable Microsoft livespaces
        }
      }
    }
  };

  if (movie)
  {
    config.clip.scaling='fit';

    if (typeof(this.playlists.identifier)!='undefined')
    {
      var vurl='http://www.archive.org/details/'+this.playlists.identifier;
      // enable the "email" button and start with custom pre-filled out body
      config.plugins.viral.email = {texts:{
        subject: 'Internet Archive video'+(ttl ? ' -- '+ttl : ''),
        template:'{0}\n\n Video Link: <href="'+vurl+'">'+vurl+'</a>',
        message: 'We will fill out the video link, title, and subject for you.\nYou may add an additional personal message to the body here'
        }};
    }
  }
  else
  {
    // make more room for the scrubber bar!
    config.plugins.controls.scrubberHeightRatio= 0.6;
    config.plugins.controls.timeFontSize = 9;
    config.plugins.controls.mute = false;
    
    
    // ensure play/scrub bar stays at the top vertically of the flash container
    config.plugins.controls.top=0;

    // we have to adjust the viral plugin quite a bit for audio...
    // where the colors are to make much of the crap in it "disappear" by being
    // same color as the background...
    config.plugins.viral.top = this.CONTROLLER_HEIGHT;
    config.plugins.viral.icons = { color: '#000000',
                                   overColor: '#000000',
                                   fontColor: '#000000',
                                   lineColor: '#000000',
                                   backgroundColor: '#000000' };
    config.plugins.viral.canvas = { color: '#000000',
                                    fontColor: '#000000',  
                                    lineColor: '#000000',
                                    backgroundColor: '#000000'
    };
    // ugh!  mattes out the annoying "sometimes shows and fades" small [Share]
    // icon internal to viral plugin...
    config.plugins.viralmatte ={'url':this.flowdir+'flowplayer.content-3.2.0.swf',
                                'top': this.CONTROLLER_HEIGHT,
                                'left': (this.FLASH_WIDTH / 2),
                                'height': 26,
                                'width':'100%',
                                'zIndex': 10000,
                                'opacity': 1.0,
                                style:{ 'opacity':1.0,
                                    'borderColor':'#000000',
                                    backgroundColor:'#000000',
                                    color:'#000000',
                                    backgroundGradient:'none' }
    };
  }
    
  
  
  if (movie  &&  this.urls == playlists.mp4s)
  {
    // makes it so we can jump into any part of an h.264 movie before it loads!
    config.clip.provider = 'h264streaming';
    config.plugins.h264streaming = {
      url:this.flowdir+'flowplayer.pseudostreaming-3.2.1.swf'
    };
  }

  if (typeof(playlists.identifier)!='undefined')
  {
    var label=(movie?'View+':'Listen+to+')+playlists.identifier+'+at+archive.org';
    var cm = [
    {
    },
    '-',
    'Flowplayer v3.2.1'
    ];

    cm[0][label] = function(){ location.href = 'http://www.archive.org/details/' + playlists.identifier; };
    
    config.contextMenu = cm;
  }
  



  // setup any captioning if relevant
  this.captioned = this.captionSetup(config);
  


  
  //console.log(config);
  this.embedthis(config);
  this.config = config;
},


audioShare:function()
{
  if (!this.player)
  {
    alert('this feature requires our flash-based player to be used');
    return false;
  }

  var fpdiv = document.getElementById(this.flowplayerdiv);
  if (this.audioSharingShowing)
  {
    this.player.getPlugin('viral').fadeOut();
    this.player.getPlugin('viral').hide();
    fpdiv.style.height = this.CONTROLLER_HEIGHT;
    this.audioSharingShowing = false;
  }
  else
  {
    fpdiv.style.height=this.CONTROLLER_HEIGHT + this.AUDIO_HEIGHT;
    IAPlay.player.getPlugin('viral').fadeIn();
    this.audioSharingShowing = true;
  }
  return false;  
},


showPlayer:function()
{
  if (!this.htm5  &&  !this.flashOK())
    return false;

  
  var movie = this.movie;

  var flashed = document.getElementById(this.flowplayerdiv+'_api');
  var fpdiv = document.getElementById(this.flowplayerdiv);
  if (!movie  &&  flashed)
  {
    // OK this is wack.  lemme 'splain...
    // This is an audio item, and means flowplayer has already inserted a flash
    // plugin into the "flowplayerdiv".  We get here pretty much only when
    // the user is clicking the "try the new <audio> tag" (and not cookied).
    // Ideally, we'd just like to insert new <audio> tag HTML into flowplayerdiv.
    // BUT!  NOT SO FAST!  8-)
    // The prior flash "install" put a bunch of event handling stuff and hex
    // cursed the div (so the <audio> tag play/pause and mute/unmute buttons
    // weren't working).  Solution?  make a brand new clean div, and "steal"
    // the "id" back;  and tell the flash div to STFU...
    var fresh = document.createElement('div');
    fresh.style.width  = fpdiv.style.width;
    fresh.id = this.flowplayerdiv;

    fpdiv.id = 'kickedoldskool';
    fpdiv.style.height = 1;
    fpdiv.style.width = 1;
    fpdiv.innerHTML = '';
    fpdiv.display = 'none';
    fpdiv.parentNode.insertBefore(fresh, fpdiv);

    // now re-get the div for the id...
    fpdiv = document.getElementById(this.flowplayerdiv);
  }
  else
  {
    // handle flowplayer bug (IMHO) where when it embeds a mp3(s) flash container
    // into a DIV that is *not* blank/empty, player is invisible and you have to
    // click on the DIV first (?!)
    fpdiv.innerHTML = ' ';
  }
  
  this.flowplayerplaylist = document.getElementById("flowplayerplaylist");

  
  
  if (movie)
  {
    if (!this.htm5)
      this.hide('tryVideo');
    
    // set div's width & height (flowplayer flash obj maximizes into it)
    fpdiv.style.width  = '100%';
    fpdiv.style.height = this.VIDEO_HEIGHT + (this.htm5 ? 0 :
                                              this.CONTROLLER_HEIGHT);
    if (this.flowplayerplaylist)
      this.flowplayerplaylist.style.width =  this.FLASH_WIDTH;

    this.config.clip.onMetaData  = function(clip) { IAPlay.shrinkToFit(clip); };
  }
  else
  {
    fpdiv.style.height = this.CONTROLLER_HEIGHT;
    if (this.htm5)
      this.hide('shareA1');
  }


  

  
  // by avid movie fans request -- since we will be playing the movie now,
  // replace animated GIF in upper left (where applicable) with single Thumbnail!
  var thumb = document.getElementById('thumbnail');
  if (thumb  &&  movie  &&  typeof(this.playlists.identifier)!='undefined'  &&
      typeof(thumb.src)!='undefined')
  {
    thumb.src = 'http://www.archive.org/download/'+this.playlists.identifier+
      '/format=Thumbnail';
  }
  
  

  // create Flowplayer instance into DIV element whose id="flowplayerdiv"
  if (!this.htm5)
    this.player = $f(this.flowplayerdiv, this.playerSwfUrl, this.config);

  

  if (!this.flowplayerplaylist)
    return false;
  

  if (!this.htm5)
  {
    //flowplayer API callbacks that we use to get flash events when they happen
    if (this.flowplayerplaylist)
    {
      if (!this.movie)
      {
        this.player.onMouseOut(function() {
            if (IAPlay.audioSharingShowing)
              IAPlay.audioShare();
          });
      }
      
      
      // if playlist present, show the clip's "play triangle" icon; hide the rest
      this.player.onBegin(function() {
          IAPlay.ready = true;

          var clipnum = $f().getClip().index;
          //console.log("UPDATING TO CLIP: "+clipnum);
          
          if (IAPlay.captioned)
            IAPlay.caption(clipnum);

          IAPlay.indicateIsPlaying(clipnum);
        });
      
      // if we are supposed to seek movie ahead, do so when (first) clip starts
      if (this.start)
      {
        this.player.onStart(function() {
            if (IAPlay.start)
            {
              IAPlay.player.pause();
              IAPlay.player.seek(IAPlay.start);
              IAPlay.player.resume();
            }
            
            IAPlay.start = 0;
          });
      }
    }
  }
  


  

  var table = '<table class="fplay" border="1">\n';
  for (var i=0; i<this.names.length; i++)
  {
    var name = this.names[i];
    var col3 = (typeof(this.playlists.lengths)=="undefined"?"":
                "<td class=\"c3\">"+
                this.playlists.lengths[i]+"</td>");
    if (this.captioned)
    {
      if (typeof(this.captions[i])=='undefined')
      {
        col3 = '<td class="c3"> </td>';
      }
      else
      {
        var str = '';
        for (var lang in this.captions[i])
          str += (str?' | ':'') + ' <span style="padding:0 5 0 5" id="kap.'+
            i+'.'+lang+'"><a onclick="return IAPlay.caption('+i+',\''+
            lang+'\')" href="'+this.captions[i][lang]+'">'+lang+'</a></span>';
        col3 = '<td class="c3"><nobr>Captions:</nobr> <nobr>[ '+ str +' ]</nobr></td>';
      }
    }
    
    
    table +=
      //NOTE: clicking the row fires an onBegin() event
      '<tr onclick="return IAPlay.playClip('+i+')" class="'+
      (i%2 ? 'eve' : 'odd') + "\"><td class=\"c1\">"+(i+1)+
      "<img src=\"/images/orange_arrow.gif\"/></td><td>"+name+'</td>' + col3+
      "</tr>\n";
  }
  table += "</table>\n";
  //console.log(table);

  this.flowplayerplaylist.innerHTML = table;

  // hold is only used for the <audio> tag w.r.t. the *load* of an audio details
  // page -- where the player should not play or buffer the audio at that point
  if (!movie  &&  this.htm5  &&  !this.tryingHTM5)
    this.hold = true;
  
  if (this.htm5)
    this.playClip(0);
  
  return false;
},

  
// dynamically resizes the flowplayer div / video tag
// (and playlist, when applicable) to auto-center and have minimal blackbars!!
shrinkToFit:function(clip)
{
  var viddiv=0, vidSrcWidth=0,  vidSrcHeight=0;
  if (typeof(clip)=='undefined')
  {
    // video tag
    viddiv = document.getElementById('iavtag');
    if (viddiv)
    {
      vidSrcWidth  = viddiv.videoWidth;
      vidSrcHeight = viddiv.videoHeight;
    }
  }
  else
  {
    // flowplayer
    viddiv = document.getElementById(this.flowplayerdiv);
    vidSrcWidth  = clip.metaData.width;
    vidSrcHeight = clip.metaData.height;
  }

  if (!viddiv)
    return; // should never happen, but be safe!

  
  
  var newPlayerWidth =
    Math.round(this.VIDEO_HEIGHT * (1.0 * vidSrcWidth/vidSrcHeight));
  IAD.log(vidSrcWidth+'x'+vidSrcHeight+' => '+newPlayerWidth+'x'+this.VIDEO_HEIGHT);
  viddiv.style.width = newPlayerWidth;
  var el = document.getElementById('flowplayerplaylist');
  if (el)
    el.style.width = newPlayerWidth;
},


// marks the playlist row for the video that is playing w/ orange triangle
indicateIsPlaying:function(clipnum)
{
  var els = IAPlay.flowplayerplaylist.getElementsByTagName("img");
  for (var i=0; i < els.length; i++)
    els[i].style.visibility = (i==clipnum ? 'visible' : 'hidden');
},


playme:function(mpg, ogg)
{
  if (typeof(this.playable)=='undefined')
  {
    var avtag = document.createElement('video');
    this.playable = {'video/mp4' :false,
                     'video/ogg' :false, 
                     'audio/mpeg':false,
                     'audio/ogg' :false};
    for (var ty in this.playable)
    {
      // answers may be: '', 'no', 'maybe', 'probably' (that is awesome 8-)
      if (avtag.canPlayType(ty))
        this.playable[ty] = true;
    }
    IAD.log('playable: '+JSON.stringify(this.playable));
  }

  return (this.movie ?
          ((mpg  &&  this.playable['video/mp4' ]) ? mpg :
           (ogg  &&  this.playable['video/ogg' ]) ? ogg : '') :
          ((mpg  &&  this.playable['audio/mpeg']) ? mpg :
           (ogg  &&  this.playable['audio/ogg' ]) ? ogg : ''));
},


playClip:function(idx)
{
  try
  {
    if (!this.htm5)
    {
      // flash player
      $f().play(idx);
      return false;
    }


    // <video> or <audio> tag!

    IAD.log('playClip:'+idx);
    var tp = this.playlists;
    var olen=0, mlen=0, ogg='', mpg='';
    
    if (this.movie)
    {
      olen = (typeof(tp.ogvs)!='undefined' ? tp.ogvs.length : 0);
      mlen = (typeof(tp.mp4s)!='undefined' ? tp.mp4s.length : 0);
      ogg = (idx < olen ? this.playlists.ogvs[idx] : '');
      mpg = (idx < mlen ? this.playlists.mp4s[idx] : '');
    }
    else
    {
      olen = (typeof(tp.oggs)!='undefined' ? tp.oggs.length : 0);
      mlen = (typeof(tp.mp3s)!='undefined' ? tp.mp3s.length : 0);
      ogg = (idx < olen ? this.playlists.oggs[idx] : '');
      mpg = (idx < mlen ? this.playlists.mp3s[idx] : '');
    }
    //console.log(ogg,mpg);
    if (!ogg  &&  !mpg)
    {
      if (!mlen  ||  !olen)
        this.warn('Sorry!  no clips in this item could be played with the &lt;'+
                  this.htm5+'&gt; tag.');
      return false;
    }
    
    var pre = 'http://www.archive.org/download/'+this.playlists.identifier+'/';
    //if (!this.movie) pre = 'http://' + this.playlists.server + this.playlists.mainDir + '/';//xxxx
    
    var tmp = this.playme(mpg, ogg);
    if (!tmp)
    {
      this.warn('Sorry!  Your browser could not play any of the available file formats for this '+(this.movie ? 'video' : 'recording'));
      return false;
    }
    var avfile = pre + tmp;
    

    var iavtag = document.getElementById('iavtag');
    if (!iavtag)
    {
      IAD.log('new av tag');

      var fpdiv = document.getElementById(this.flowplayerdiv);
      fpdiv.innerHTML =
        (this.movie ? '<video' : '<audio') + ' id="iavtag" controls="controls"'+
        (this.hold ? '' : ' autoplay="autoplay" autobuffer="autobuffer"')+
        ' src="'+avfile+'"'+
        //NOTE *not* explicitly setting width lets widescreen films show correct
        (this.movie ? ' height="'+this.VIDEO_HEIGHT+'"' : '')+
        ">\n"+ (this.movie ? "</video>\n" : "</audio>\n");

      iavtag = document.getElementById('iavtag');
      
      if (this.hold)
        this.hold = false;
      
      if (iavtag  &&  typeof(iavtag.addEventListener)!='undefined')
      {
        if (this.movie)
          iavtag.addEventListener("loadeddata", function(){IAPlay.shrinkToFit();},false);
        iavtag.addEventListener("ended", function(){IAPlay.clipEnded();},true);
      }
    }
    else
    {
      // slick!  basically like:
      // http://developer.apple.com/safari/library/documentation/AudioVideo/Conceptual/Using_HTML5_Audio_Video/ControllingMediaWithJavaScript/ControllingMediaWithJavaScript.html#//apple_ref/doc/uid/TP40009523-CH3-SW5

      if (iavtag.src != avfile)
      {
        IAD.log('updating AV source to:'+avfile);
        iavtag.src = avfile;
      }
      
      iavtag.load();
      iavtag.play();
    }
    
    IAD.log(iavtag);
    
    this.playingClipNum = idx;
    
    this.indicateIsPlaying(idx);
  }
  catch (E)
  {
    IAD.log(E);
  }
  return false;
},


// NOTE: only used for <video> or <audio> tag
clipEnded:function()
{
  idx = this.playingClipNum;
  IAD.log('clipEnded:'+idx);

  this.playClip(idx+1); // now play the next clip (if there is one)
},


// returns whether or not client has minimum flash plugin to play movies or mp3s
// turning on warning messages if they do not!
flashOK:function()
{
  if (this.flashFailed) // dbl check against 2+ presses of click2play when !flash
    return false;

  if (!this.htm5  &&
      IAPlay.checkFlashUpgradeNeeded(IAPlay.MIN_FLASH_VERSION))
  {
    this.flashFailed = true;
    return false;
  }
  if (this.playing264  &&  !flashembed.isSupported(IAPlay.MP4_FLASH_VERSION))
  {
    this.warn(
      'Newer versions of the flash plugin can play this item\'s videos -- ' +
      'Adobe Flash Player version ' + IAPlay.MP4_FLASH_VERSION +
      ' or higher.<br/>'+
      '<small>(It appears you have version: '+flashembed.getVersion()+
      ')</small><br/>'+
      '<a href="http://www.adobe.com/go/getflash/">Get current Flash version</a>');
    this.flashFailed = true;
    return false;
  }

  return true;
},


// subtitles/captions
captionSetup:function(config)
{
  var playlists = this.playlists;
  
  if(!this.movie || typeof(playlists.srts)=='undefined' || !playlists.srts.length)
    return false;

  var captioned = false;
  
  for (var j=0, srt; srt=playlists.srts[j]; j++)
  {
    // given semi-arbitrary names like:
    //   "movie.srt"
    //   "track1.srt"
    //   "track1.fr.srt"
    //   "track1.sp.srt"
    // try to match it to the most appropriate video clip
    var base1 = srt.substr(0, srt.length-4); // nix ".srt" suffix
    var base2 = base1.replace(/[_\-\.][^_\-\.]+$/,'');
    var lang='';      
    if (base2 != base1)
    {
      // save the likely "language" portion we just found
      lang = base1.substr(base2.length+1);
      // srt:   track1.something.srt
      // base1: track1.something
      // base2: track1
      // lang:  something
    }
    //console.log(srt,base1,base2,lang);
    
    // now search the videos to see what it matches best to (if any)
    var bestmatch1=null;
    var bestmatch2=null;
    for (var idx=0, clip; clip=config.playlist[idx]; idx++)
    {
      var parts = clip.split('/');
      var vidname = (parts[parts.length-2] + '/' +
                     parts[parts.length-1].replace(/(_512kb)*\.mp4$/,''));

      //console.log(idx, vidname);
      if (vidname == base1)  bestmatch1 = idx;
      if (vidname == base2)  bestmatch2 = idx;
    }
    
    if      (bestmatch1 != null) idx = bestmatch1;//NOTE: prefer longest match!
    else if (bestmatch2 != null) idx = bestmatch2;
    else if (config.playlist.length==1) idx = 0;  //only *1* video track -- match!
    else break;

    if (typeof(this.captions[idx])=='undefined')
      this.captions[idx] = {}
    
    if (!lang)
    {
      // default to "en" if no language found above and it hasnt been "used" yet
      if (typeof(this.captions[idx]['en'])=='undefined')
      {
        lang = 'en';
      }
      else
      {
        // basically back off / give up and use the filename
        lang = srt.substr(srt.lastIndexOf('/')+1);
        lang = lang.substr(0, lang.length - 4); // nix ".srt" suffix
      }
    }
    
    //console.log(bestmatch1, bestmatch2, idx, lang);
    
    
    var captionUrl =
      'http://'+location.host+'/download/' + this.playlists.identifier +'/' + srt;
    
    //console.log(caption);
    this.captions[idx][lang] = captionUrl;
    captioned = true;
  }

  if (!captioned)
    return false;
  

  config.clip.showCaptions = true;

  
  // If 1st video has srt, set it up (really just for embed code users)
  for (var j in this.captions[0])
  {
    config.clip.captionUrl = this.captions[0][j];
    break;
  }

  
  // configure a content plugin so that it looks good for showing
  config.plugins.captions  = { 'url':this.flowdir+'flowplayer.captions-3.2.0.swf',
                               captionTarget: 'content' };
  config.plugins.content = {
    display: 'none', // start *not* showing captions
    'url':this.flowdir+'flowplayer.content-3.2.0.swf', 
    bottom: this.CONTROLLER_HEIGHT,
    left:   0,
    width: '100%',
    height: 50,
    backgroundGradient: 'none',
    backgroundColor: 'transparent',
    textDecoration: 'outline', // very important for readability in fullscreen!
    border: 0, 
    style: {
      'body': {
      fontSize: '14',
      fontFamily: 'Arial',
      textAlign: 'center', 
      fontWeight: 'bold',
      color: '#ffffff' //white
      }
    }
  };
  // config.log = { level:'debug' };
  
  return true;
},


caption:function(idx, lang)
{
  if (this.ready)
  {
    var clip = this.player.getClip(idx);

    if (typeof(lang)=='undefined')
    {
      // new clip is starting -- arbitrarily pick the first language
      lang = false;
      for (var i in this.captions[idx])
      {
        lang=i;
        break;
      }
      if (!lang)
      {
        this.player.getPlugin('captions').loadCaptions(idx, this.emptySRT);
        return false; // this particular clip has no subtitles.  nothing to do!
      }
    }
    
    
    // keep in mind there could be 2+ languages/caption choices per video!
    var desired = this.captions[idx][lang];

    //console.log('show caption '+lang+' please for clip #'+idx);

    this.player.getPlugin('captions').loadCaptions(idx, desired);

    if (this.lastCaptionID)
    {
      var el = document.getElementById(this.lastCaptionID);
      el.style.backgroundColor = 'black';
    }

    this.lastCaptionID = 'kap.'+idx+'.'+lang;
    var el = document.getElementById(this.lastCaptionID);
    el.style.backgroundColor = 'red';
  }
  return false;
},


// parse a CGI arg
arg:function(theArgName)
{
  sArgs = location.search.slice(1).split('&');
  r = '';
  for (var i=0; i < sArgs.length; i++)
  {
    if (sArgs[i].slice(0,sArgs[i].indexOf('=')) == theArgName)
    {
      r = sArgs[i].slice(sArgs[i].indexOf('=')+1);
      break;
    }
  }
  return (r.length > 0 ? unescape(r).split(',') : '')
},


// inserts embedding HTML to allow a user to embed our flash player on their site
embedthis:function(config)
{
  if (typeof(config)!='undefined') // means we are setting up
  {
    // NOTE: JSON.stringify() defined in details.js!
    // NOTE: JSON.parse()     defined in details.js!
    var str = JSON.stringify(config); // helps us w/ deep copy/clone!

    if (this.movie)
    {
      // insert a thumnail image to the start of the playlist -- it will autoplay.
      // then, make the 1st video not autoplay (requiring click-to-play)
      str = str.replace(/"playlist":\[([^,\]]+)/,
                        '"playlist":["format=Thumbnail?.jpg",{"autoPlay":false,"url":$1}');
    }
    var c = JSON.parse(str);
      
    c.canvas.backgroundColor='#000000'; // black bg for nice and crisp look
    c.plugins.controls.backgroundColor = '#000000';


    // adjust the captions, when present, to not messup the whole embed code!
    if (typeof(c.plugins.content)!='undefined')
    {
      c.plugins.content.width = this.FLASH_WIDTH;
      c.plugins.content.display = 'block'; // default to show them
    }

    
    // remove viral plugin since it wont autohide
    var nixplugins={'viralmatte':true,'viral':true};
    // audio not needed for videos so let's shorten embed code!
    if (this.movie)
      nixplugins['audio']=true;

    var newplugins = {}
    for (key in c.plugins)
    {
      if (typeof(nixplugins[key])=='undefined')
        newplugins[key] = c.plugins[key];
    }
    c.plugins = newplugins;
    //console.log(newplugins);

    
    var configStr = JSON.stringify(c).replace(/\"/g,"'");
    
    

    // Take verbatim from PlayerEmbed.as (source of viralvideos*.swf)
    // then modified:
    //   - JS variable names in string concat-ing renamed to our world
    //   - make sure <embed> uses an actual </embed> for sites like blogger.com!
    //   - extra whitespace chars removed
    //   - quality="true" ==> "high"   (?!!! 8-)
    //   - minor reorder of last 3 key="val" params in <embed> (for cleanliness!)
    var width  = this.FLASH_WIDTH;
    var height = (this.movie ? this.VIDEO_HEIGHT : 0) + this.CONTROLLER_HEIGHT;
    this.embedTag = '<object width="' + width + '" height="' + height + '" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000">' +
    '<param value="true" name="allowfullscreen"/>' +
    '<param value="always" name="allowscriptaccess"/>' +
    '<param value="high" name="quality"/>' +
    '<param value="true" name="cachebusting"/>' +
    '<param value="#000000" name="bgcolor"/>' +
    '<param name="movie" value="' + this.playerSwfUrl + '" />' +
    '<param value="config=' + configStr + '" name="flashvars"/>' +
    '<embed src="' + this.playerSwfUrl + '" type="application/x-shockwave-flash" width="' + width + '" height="' + height + '" allowfullscreen="true" allowscriptaccess="always" cachebusting="true" bgcolor="#000000" quality="high" flashvars="config=' + configStr + '"> </embed>' +
    '</object>';

    //console.log(c);
    //console.log(this.embedTag);

    
    // this.warn(this.embedTag);//uncomment to test embed code inline in page!
    
  
    
    // we will be putting this inside a value of form "text" elem...  
    this.embedTag = this.embedTag.replace(/\"/g, '&quot;');

    var et = document.getElementById('embedthis');
    if (!et)
      return false;
    et.innerHTML = '<small><a href="http://www.archive.org/about/javascript-required.htm" onclick="return IAPlay.embedthis()">embed this</a></small>';

    if (this.movies  &&  location.host.substr(0,4)=='www-')
    {
      var obj = document.getElementById('flowplayercontainer');
      var clipthis = document.createElement('div');
      clipthis.id = 'clipthis';
      clipthis.style.width = 640;
      clipthis.innerHTML = '<small><a href="http://www.archive.org/about/javascript-required.htm" onclick="return IAPlay.clipthis()">bookmark a clip</a></small>';
      obj.appendChild(clipthis);
    }
  }
  else
  {
    var str = '<div style="padding:2px; background-color:#ddd; border:1px dashed gray;">' +
      'Simply copy the code below and paste it into your webpage:<br/><input style="border:1px solid gray;" id="embed" type="text" size="20" onclick="document.getElementById(\'embed\').focus(); document.getElementById(\'embed\').select();" readonly="readonly" value="'+this.embedTag+'"/>' +
      '<hr/>  NOTE: We are not able to offer a simple piece of HTML to show the playlist along with the player.' +
      '</div>';

    var obj=document.getElementById('embedthis');
    obj.innerHTML = str;
  }
  return false;
},



clipthis:function()
{
  var str = '\
<div style="text-align:left; padding:5px; background-color:#ddd; border:1px dashed gray;">\
<form action="/bookmarks.php" onsubmit="return IAPlay.clipcheck()">\
Selecting and bookmarking a clip <img src="/images/cut.png"> from this video is easy:<br/>\
Start playing the video.<br/>\
Press this button: <a onclick="return IAPlay.clippoint(\'start\')" href="#"><img src="/images/resultset_next.png"></a>\
  when you want your clip to START.\
  <span id="startbox" style="display:none">[ Time: <input id="startpt" type="text" name="start" value="">]</span><br/>\
Press this button: <a onclick="return IAPlay.clippoint(\'end\')" href="#"><img src="/images/resultset_previous.png"></a>\
  when you want your clip to END.\
  <span id="endbox" style="display:none">[ Time: <input id="endpt" type="text" name="end" value="">]</span><br/>\
  <input type="hidden" id="mediabox" name="media">\
  <input type="hidden" name="add_bookmark" value="1">\
  <input type="hidden" name="identifier" value="'+(this.playlists.identifier)+'">\
  <input type="hidden" name="title" value="'+(this.playlists.title)+'">\
  <input type="hidden" name="mediatype" value="'+(this.playlists.mediatype)+'">\
  <input type="submit"></form>\
</div>\
';
  
  document.getElementById('clipthis').innerHTML = str;
  return false;
},


clippoint:function(startend)
{
  var ptime = this.player.getTime();
  var el;
  //console.log(this.player.getClip().completeUrl, ptime);

  el = document.getElementById(startend+'pt');
  el.value = ptime;

  el = document.getElementById(startend+'box');
  el.style.display='inline';

  var url = this.player.getClip().completeUrl;
  el = document.getElementById('mediabox');
  el.value = url.substr(url.lastIndexOf('/')+1);
},
  

clipcheck:function()
{
  var startpt = document.getElementById('startpt').value;
  var endpt   = document.getElementById('endpt'  ).value;
  if (!startpt && endpt)
    return true;
  if (startpt && !endpt)
    return true;
  if (parseFloat(startpt) < parseFloat(endpt))
    return true;
  alert('Your start point must come before your end point.  Please adjust and re-submit.');
  return false;
},

  

tryVideoTag:function()
{
  this.htm5 = (this.movie?'video':'audio');
  var obj = document.getElementById('tryVideo');
  if (obj)
  {
    obj.innerHTML = 'You may <a href="#" onclick="return IAPlay.cookieVideoTag()">click here</a> to always use the &lt;'+this.htm5+'&gt; tag<br/>(we will set a cookie).';
  }

  this.tryingHTM5 = true;
  this.showPlayer();

  return false;
},

cookieVideoTag:function()
{
  var obj = document.getElementById('tryVideo');
  if (obj)
    obj.innerHTML = 'Your preference for &lt;'+this.htm5+'&gt; tag has been set!  Enjoy!';
  this.setCookie('videoTag','1',180,'/details');// persist the choice for 6 months
  return false;
},

uncookieVideoTag:function()
{
  var obj = document.getElementById('tryVideo');
  if (obj)
    obj.innerHTML = 'Thanks for trying the &lt;'+this.htm5+'&gt; tag!  Reload page if desired!';
  this.setCookie('videoTag','0',-1);            // make cookie expire
  this.setCookie('videoTag','0',-1,'/details'); // make cookie expire
  return false;
},

// from http://www.w3schools.com/JS/js_cookies.asp
setCookie:function(c_name,value,expiredays,path)
{
  var exdate=new Date();
  exdate.setDate(exdate.getDate()+expiredays);

  var str = 
    (c_name+ "=" +escape(value)+
     ((expiredays==null) ? "" : "; expires="+exdate.toGMTString()) +
     (typeof(path)=='undefined' ? '' : '; path='+path))
    // safari5 stopped allowing "GMT", ouch!  (tracey july2010)
    .replace(/ GMT/, ' UTC'); 

  //IAD.log(str);
  document.cookie = str;
},

// modified from: http://www.w3schools.com/JS/js_cookies.asp
getCookie:function(c_name)
{
  if (document.cookie.length>0)
  {
    c_start=document.cookie.indexOf(c_name + "=");
    if (c_start!=-1)
    { 
      c_start=c_start + c_name.length+1; 
      c_end=document.cookie.indexOf(";",c_start);
      if (c_end==-1) c_end=document.cookie.length;
      
      return decodeURIComponent(document.cookie.substring(c_start,c_end).replace(/\+/g,' '));
    } 
  }
  return "";
},

unhide:function(i)
{
  var e=document.getElementById(i);
  if (e) e.style.display = 'block';
  return false;
},
  
hide:function(i)
{
  var e=document.getElementById(i);
  if (e) e.style.display = 'none';
  return false;
},
  
toggle:function(i)
{
  var e=document.getElementById(i);
  if (e)
    e.style.display=(e.style.display!='block'?'block':'none');
  return false;
},



click2play:function()
{
  var ogv = (typeof(this.playlists.ogvs)!='undefined'  &&
             this.playlists.ogvs.length > 0 ? this.playlists.ogvs[0] : '');
  

  if (ogv  &&  navigator.userAgent.indexOf('OLPC/') >= 0)
  {
    // OLPC cutie green machine -- gnash shipped with it can't seem to play
    // our h.264 files (yet!) but it can play "Ogg Video"
    // Feed them (the first) ogg video...
    clik = '<a href="/download/' + this.playlists.identifier + '/' + ogv + '"';
  }
  else
  {
    clik =
      '<a href="/about/javascript-required.htm" '+
      ' onClick="return IAPlay.showPlayer()"';
  }

  
  str =
    '<div style="margin-left:auto; margin-right:auto; width:'+
    IAPlay.CLIK2PLAYWIDTH+'; height:'+IAPlay.CLIK2PLAYHEIGHT+
    'px; text-align:center; position:relative;">' +
    '<div style="width:'+IAPlay.CLIK2PLAYWIDTH+
    '; position:absolute; top:0; left:0;">';

  var thumbs=this.playlists.thumbs;
  
  var l=thumbs.length;
  /**/ if (l==1)thumbA2 = new Array(thumbs[0], null,      null,      null);
  else if (l==2)thumbA2 = new Array(thumbs[0], null,      null,      thumbs[1]);
  else if (l==3)thumbA2 = new Array(thumbs[0], thumbs[1], thumbs[2], null);
  else if (l>=4)thumbA2 = new Array(thumbs[0], thumbs[1], thumbs[2], thumbs[3]);
  else          thumbA2 = new Array(null,      null,      null,      null);
    
        
  // show up to first 4 thumbs, in 2x2 grid
  // add 10px solid black bar on top and bottom of overall grid
  var prefix = (this.playlists.server ? 'http://'+this.playlists.server : '');
  for (i=0; i < 4; i++)
  {
    str +=
      clik +
      '><img alt="click to play movie" title="click to play movie" style="border:0; border'+
      (i < 2 ? '-top' : '-bottom') +
      ':10px solid black; width:160px; height:110px;" ' +
      (thumbA2[i] ?
       'src="'+ prefix + thumbA2[i] + '"/>' :
       'src="/images/movies.gif">') +
      '</a>';
    if (i % 2 == 1)
      str += '<br/>';
  }

  
  str +=
    clik + ' onmouseover="document.getElementById(\'c2pimg\').src=\'/images/clicktoplay_over.png\'" onmouseout="document.getElementById(\'c2pimg\').src=\'/images/clicktoplay_click.png\'"' +
    '><img id="c2pimg" alt="click to play movie" title="click to play movie" style="position:absolute; top:0px; left:0px; height:'+
    IAPlay.CLIK2PLAYHEIGHT+'px; width:'+IAPlay.CLIK2PLAYWIDTH+
    'px; z-index:2; border:0px;" src="/images/clicktoplay_click.png"/></a>';

  
  str += '</div></div>';
  //console.log(str);
  
  document.getElementById('flowplayerdiv').innerHTML = str;
},


warn:function(str)
{
  var obj = document.getElementById('flowplayercontainer');
  if (obj)
  {
    var warn = document.createElement('div');
    warn.className='urge flashme';
    warn.innerHTML = str;
    obj.appendChild(warn);
  }
  else
  {
    alert(str);
  }
},


checkFlashUpgradeNeeded:function(requiredVersion)
{
  // NOTE: wrap "flashembed" object calls with try/catch because upon flowplayer
  // upgrade to v3.2.1 (may2010) when flash plugin is disabled in firefox,
  // these calls started blowing up 8-(
  try { if (flashembed.isSupported(requiredVersion)) return false; } catch(E) {}


  var currentVersion = '0,0';
  try { currentVersion = flashembed.getVersion(); } catch(E) {}
  
  var uhave = (currentVersion=='0,0' ?
               ' you do not have flash installed or have it disabled' :
               ' you have version: '+currentVersion+'');
  this.warn(
    'Internet Archive\'s<!--\'--> in-browser media player requires '+
    'Adobe Flash Player version ' + requiredVersion + ' or higher.<br/>'+
    '<small>(It appears '+uhave+')</small><br/>'+
    '<a href="http://www.adobe.com/go/getflash/">Get current Flash version</a>');
  
  return true;
}
}; // end IAPlay definition


// JSON.stringify() and JSON.parse() definitions
// minified FROM http://www.json.org/json2.js
if(!this.JSON){JSON=function(){function f(n){return n<10?"0"+n:n}Date.prototype.toJSON=function(key){return this.getUTCFullYear()+"-"+f(this.getUTCMonth()+1)+"-"+f(this.getUTCDate())+"T"+f(this.getUTCHours())+":"+f(this.getUTCMinutes())+":"+f(this.getUTCSeconds())+"Z"};String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(key){return this.valueOf()};var cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,escapeable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"},rep;function quote(string){escapeable.lastIndex=0;return escapeable.test(string)?'"'+string.replace(escapeable,function(a){var c=meta[a];if(typeof c==="string"){return c}return"\\u"+("0000"+(+(a.charCodeAt(0))).toString(16)).slice(-4)})+'"':'"'+string+'"'}function str(key,holder){var i,k,v,length,mind=gap,partial,value=holder[key];if(value&&typeof value==="object"&&typeof value.toJSON==="function"){value=value.toJSON(key)}if(typeof rep==="function"){value=rep.call(holder,key,value)}switch(typeof value){case"string":return quote(value);case"number":return isFinite(value)?String(value):"null";case"boolean":case"null":return String(value);case"object":if(!value){return"null"}gap+=indent;partial=[];if(typeof value.length==="number"&&!(value.propertyIsEnumerable("length"))){length=value.length;for(i=0;i<length;i+=1){partial[i]=str(i,value)||"null"}v=partial.length===0?"[]":gap?"[\n"+gap+partial.join(",\n"+gap)+"\n"+mind+"]":"["+partial.join(",")+"]";gap=mind;return v}if(rep&&typeof rep==="object"){length=rep.length;for(i=0;i<length;i+=1){k=rep[i];if(typeof k==="string"){v=str(k,value);if(v){partial.push(quote(k)+(gap?": ":":")+v)}}}}else{for(k in value){if(Object.hasOwnProperty.call(value,k)){v=str(k,value);if(v){partial.push(quote(k)+(gap?": ":":")+v)}}}}v=partial.length===0?"{}":gap?"{\n"+gap+partial.join(",\n"+gap)+"\n"+mind+"}":"{"+partial.join(",")+"}";gap=mind;return v}return "null";}return{stringify:function(value,replacer,space){var i;gap="";indent="";if(typeof space==="number"){for(i=0;i<space;i+=1){indent+=" "}}else{if(typeof space==="string"){indent=space}}rep=replacer;if(replacer&&typeof replacer!=="function"&&(typeof replacer!=="object"||typeof replacer.length!=="number")){throw new Error("JSON.stringify")}return str("",{"":value})},parse:function(text,reviver){var j;function walk(holder,key){var k,v,value=holder[key];if(value&&typeof value==="object"){for(k in value){if(Object.hasOwnProperty.call(value,k)){v=walk(value,k);if(v!==undefined){value[k]=v}else{delete value[k]}}}}return reviver.call(holder,key,value)}cx.lastIndex=0;if(cx.test(text)){text=text.replace(cx,function(a){return"\\u"+("0000"+(+(a.charCodeAt(0))).toString(16)).slice(-4)})}if(/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,"@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,"]").replace(/(?:^|:|,)(?:\s*\[)+/g,""))){j=eval("("+text+")");return typeof reviver==="function"?walk({"":j},""):j}throw new SyntaxError("JSON.parse")}}}()};
